﻿using Infragistics.Web.UI.NavigationControls;
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {

        // Bind to IEnumerable, declarative bindings
        this.WebDataTree1.DataSource = GetBooks();

        DataTreeNodeBinding binding = new DataTreeNodeBinding();
        binding.ValueField = "ID";
        binding.TextField = "Title";
        binding.Depth = 0;
        binding.ImageUrlField = "ImageUrl";
        this.WebDataTree1.DataBindings.Add(binding);

        binding = new DataTreeNodeBinding();
        binding.ValueField = "ID";
        binding.TextField = "Title";
        binding.Depth = 1;
        binding.ImageUrlField = "ImageUrl";
        this.WebDataTree1.DataBindings.Add(binding);

        this.WebDataTree1.DataBind();

        // extra unbound node adding through API
        DataTreeNode node = new DataTreeNode { Text = "Extra node", Value = "test" };
        node.Nodes.Add(new DataTreeNode { Text = "Extra node child", Value = "test2" });
        WebDataTree1.Nodes.Add(node);
    }



    #region List Data
    public IList<Book> GetBooks()
    {
        List<Book> books = new List<Book>();

        books.Add(new Book { ID = 0, Title = "The Elegant Universe", Author = "Brian Greene", UnitPrice = "15.95", Url = "http://www.amazon.com/Elegant-Universe-Superstrings-Dimensions-Ultimate/dp/0393046885", ReleaseDate = "02/01/1999" });

        books[0].Chapters.Add(new Chapter { Title = "Tied Up with String" });
        books[0].Chapters.Add(new Chapter { Title = "Space, Time, and the Eye of the Beholder" });
        books[0].Chapters.Add(new Chapter { Title = "Of Warps and Ripples" });
        books[0].Chapters.Add(new Chapter { Title = "Microscopic Weirdness" });
        books[0].Chapters.Add(new Chapter { Title = "Beyond Strings: In Search of M-Theory" });
        books[0].Chapters.Add(new Chapter { Title = "Black Holes: A String/M-Theory Perspective" });
        books[0].Chapters.Add(new Chapter { Title = "Reflections on Cosmology" });
        books[0].Chapters.Add(new Chapter { Title = "Prospects" });

        books.Add(new Book { ID = 1, Title = "The Selfish Gene (30th Anniversary Edition)", Author = "Richard Dawkins", UnitPrice = "15.95", Url = "http://www.amazon.com/Selfish-Gene-Anniversary-Introduction/dp/0199291152", ReleaseDate = "05/25/2006" });

        books[1].Chapters.Add(new Chapter { Title = "Why are people?" });
        books[1].Chapters.Add(new Chapter { Title = "The replicators" });
        books[1].Chapters.Add(new Chapter { Title = "Immortal coils" });
        books[1].Chapters.Add(new Chapter { Title = "The gene machine" });
        books[1].Chapters.Add(new Chapter { Title = "Memes: the new replicators" });
        books[1].Chapters.Add(new Chapter { Title = "Nice guys finish first" });
        books[1].Chapters.Add(new Chapter { Title = "The long reach of the gene" });


        books.Add(new Book { ID = 2, Title = "The Ideological Origins of the American Revolution (Enlarged Edition)", Author = "Bernard Bailyn", UnitPrice = "24.00", Url = "http://www.amazon.com/Ideological-Origins-American-Revolution/dp/0674443020", ReleaseDate = "03/01/1992" });

        books[2].Chapters.Add(new Chapter { Title = "The Literature of Revolution" });
        books[2].Chapters.Add(new Chapter { Title = "Sources and Traditions" });
        books[2].Chapters.Add(new Chapter { Title = "Power and Liberty: A Theory of Politics" });
        books[2].Chapters.Add(new Chapter { Title = "The Logic of Rebellion" });
        books[2].Chapters.Add(new Chapter { Title = "Transformation" });
        books[2].Chapters.Add(new Chapter { Title = "The Contagions of Liberty" });
        books[2].Chapters.Add(new Chapter { Title = "Fulfillment: A Commentary on the Constitution" });

        books.Add(new Book { ID = 3, Title = "Gödel, Escher, Bach: an Eternal Golden Braid", Author = "Douglas R. Hofstadter", UnitPrice = "20.00", Url = "http://www.amazon.com/Godel-Escher-Bach-Douglas-Hofstadter/dp/B001IAM392", ReleaseDate = "01/01/1999" });

        books[3].Chapters.Add(new Chapter { Title = "The MU-puzzle." });
        books[3].Chapters.Add(new Chapter { Title = "Meaning and Form in Mathematics." });
        books[3].Chapters.Add(new Chapter { Title = "Figure and Ground." });
        books[3].Chapters.Add(new Chapter { Title = "Consistency, Completeness, and Geometry." });
        books[3].Chapters.Add(new Chapter { Title = "Recursive Structures and Processes." });
        books[3].Chapters.Add(new Chapter { Title = "The Location of Meaning." });
        books[3].Chapters.Add(new Chapter { Title = "The Propositional Calculus." });
        books[3].Chapters.Add(new Chapter { Title = "Typographical Number Theory." });

        return books;
    }
    #endregion
}

#region Book

public class Book
{
    public int ID { get; set; }
    public string Title { get; set; }
    public string Author { get; set; }
    public string UnitPrice { get; set; }
    public string Url { get; set; }
    public string ImageUrl { get; set; }
    public string ReleaseDate { get; set; }
    public List<Chapter> Chapters { get; set; }
    public List<Chapter> OtherChapters { get; set; }

    public Book()
    {
        Chapters = new List<Chapter>();
        OtherChapters = new List<Chapter>();
        ImageUrl = "http://www.infragistics.com/samplesbrowser/samplescommon/aspnet/Common/OfficeBasicsIcons/Book.gif";
    }
}


public class Chapter
{
    public int ID { get; set; }
    public string Title { get; set; }
    public string ImageUrl { get; set; }

    public Chapter()
    {
        ImageUrl = "http://www.infragistics.com/samplesbrowser/samplescommon/aspnet/Common/SilDVSampleIcons/Generic.gif";
    }
}

#endregion